## Your iPhone Is Vulnerable to a Malware Attack Even When It’s Off

**Researchers found a way to exploit the tech that enables Apple’s Find My feature, which could allow attackers to track location when a device is powered down.**

źródło: <https://www.wired.com/story/iphone-find-my-malware-attack-vulnerability> ![google](../google/icon.png) ![facebook](../facebook/icon.png) ![amazon](../amazon/icon.png) ![twitter](../twitter/icon.png) ![linkedin](../linkedin/icon.png) ![tiktok](../tiktok/icon.png)

użytkownik: *Dan Goodin*

opublikowano: 2022.05.17

---

![Closeup view of person using iPhone](images/Ars-iPhone-Ransomware.png)

When you turn off an iPhone, it doesn’t fully power down. Chips inside the device continue to run in a low-power mode that makes it possible to locate lost or stolen devices using the Find My feature or use credit cards and car keys after the battery dies. Now researchers have devised a way to abuse this always-on mechanism to run malware that remains active even when an iPhone appears to be powered down.

It turns out that the iPhone’s Bluetooth chip — which is key to making features like Find My work — has no mechanism for digitally signing or even encrypting the firmware it runs. Academics at Germany’s Technical University of Darmstadt figured out how to exploit this lack of hardening to run malicious firmware that allows the attacker to track the phone’s location or run new features when the device is turned off.

This [video](https://vid.puffyan.us/watch?v=KrqTHd5oqVw) provides a high overview of some of the ways an attack can work.

The research is the first — or at least among the first — to study the risk posed by chips running in low-power mode. Not to be confused with iOS’s low-power mode for conserving battery life, the low-power mode (LPM) in this research allows chips responsible for near-field communication, ultra wideband, and Bluetooth to run in a special mode that can remain on for 24 hours after a device is turned off.

“The current LPM implementation on Apple iPhones is opaque and adds new threats,” the researchers wrote in a [paper](https://arxiv.org/pdf/2205.06114.pdf) published last week. “Since LPM support is based on the iPhone’s hardware, it cannot be removed with system updates. Thus, it has a long-lasting effect on the overall iOS security model. To the best of our knowledge, we are the first who looked into undocumented LPM features introduced in iOS 15 and uncover various issues.”

They added: “Design of LPM features seems to be mostly driven by functionality, without considering threats outside of the intended applications. Find My after power off turns shutdown iPhones into tracking devices by design, and the implementation within the Bluetooth firmware is not secured against manipulation.”

The findings have limited real-world value, since infections required first jailbreaking an iPhone, which in itself is a difficult task, particularly in an adversarial setting. Still, targeting the always-on feature in iOS could prove handy in post-exploit scenarios by malware such as [Pegasus](https://arstechnica.com/information-technology/2021/12/iphones-of-us-diplomats-hacked-using-0-click-exploits-from-embattled-nso) ![google](../google/icon.png) ![facebook](../facebook/icon.png) ![amazon](../amazon/icon.png) ![twitter](../twitter/icon.png) ![linkedin](../linkedin/icon.png) ![tiktok](../tiktok/icon.png), the sophisticated smartphone exploit tool from Israel-based NSO Group, which governments worldwide routinely employ to spy on adversaries.

It may also be possible to infect the chips in the event hackers discover security flaws that are susceptible to over-the-air exploits similar to [this one](https://arstechnica.com/information-technology/2019/08/new-attack-exploiting-serious-bluetooth-weakness-can-intercept-sensitive-data) ![google](../google/icon.png) ![facebook](../facebook/icon.png) ![amazon](../amazon/icon.png) ![twitter](../twitter/icon.png) ![linkedin](../linkedin/icon.png) ![tiktok](../tiktok/icon.png) that worked against Android devices.

Besides allowing malware to run while the iPhone is turned off, exploits targeting LPM could also allow malware to operate with much more stealth since LPM allows firmware to conserve battery power. And, of course, firmware infections are extremely difficult to detect since it requires significant expertise and expensive equipment.

The researchers said Apple engineers reviewed their paper before it was published, but company representatives never provided any feedback on its contents. Apple representatives didn’t respond to an email seeking comment for this story.

Ultimately, Find My and other features enabled by LPM help provide added security, because they allow users to locate lost or stolen devices and lock or unlock car doors even when batteries are depleted. But the research exposes a double-edged sword that, until now, has gone largely unnoticed.

“Hardware and software attacks similar to the ones described have been proven practical in a real-world setting, so the topics covered in this paper are timely and practical,” said John Loucaides, senior vice president of strategy at firmware security firm Eclypsium. “This is typical for every device. Manufacturers are adding features all the time, and with every new feature comes a new attack surface.”

This story originally appeared on [Ars Technica](https://arstechnica.com/information-technology/2022/05/researchers-devise-iphone-malware-that-runs-even-when-device-is-turned-off) ![google](../google/icon.png) ![facebook](../facebook/icon.png) ![amazon](../amazon/icon.png) ![twitter](../twitter/icon.png) ![linkedin](../linkedin/icon.png) ![tiktok](../tiktok/icon.png).
